package ar.com.unobtainium.tonetennis.sound 
{
	import flash.media.Sound;
    import flash.events.SampleDataEvent;
    import flash.events.Event;
	
	/**
	 * ...
	 * @author Balthazar Auger
	 */
	public class Hum 
	{
		protected const RATE:Number = 44100;
        protected var _position:int = 0;
        protected var _sound:Sound;
        protected var _numSamples:int = 2048;
        protected var _samples:Vector.<Number>;
        protected var _isPlaying:Boolean = false;
		protected var _amp:Number = 0.3;
		
		protected var _frequency:Number;
		
		public function Hum(frequency:int) 
		{
			_frequency = frequency;
            _sound = new Sound();
            _sound.addEventListener(SampleDataEvent.SAMPLE_DATA, onSampleData);
		}
		
		public function play():void
        {
            if(!_isPlaying)
            {
                _sound = new Sound();
				_sound.addEventListener(SampleDataEvent.SAMPLE_DATA, onSampleData);
				_sound.play();
                _isPlaying = true;
            }
        }
		
		public function stop():void
		{
			_sound.removeEventListener(SampleDataEvent.SAMPLE_DATA, onSampleData);
			_sound = null;
			_isPlaying = false;
		}
		
		protected function onSampleData(event:SampleDataEvent):void
        {
            for(var i:int = 0; i < 2048; i++)
			{
				var phase:Number = _position / 44100 * Math.PI * 2;
				_position ++;
				var sample:Number = Math.sin(phase * frequency) * _amp;
				event.data.writeFloat(sample); // left
				event.data.writeFloat(sample); // right
			}
        }
		
		public function set frequency(value:Number):void
        {
            _frequency = value;
        }
        public function get frequency():Number
        {
            return _frequency;
        }
		
		public function set volume(value:Number):void
		{
			_amp = value;
		}
		
		public function get volume():Number
		{
			return _amp;
		}
	}

}