package ar.com.unobtainium.tonetennis.sound 
{
	import flash.events.TimerEvent;
	import flash.utils.Timer;
	/**
	 * SoundMan manages the different layers of sound in the game
	 * @author Balthazar Auger
	 */
	public class SoundMan 
	{
		
		protected var hums:Array;
		protected var serveHum:Hum;
		
		protected var crash:Crash;
		
		protected var tone:Tone;
		protected var catchTone:Tone;
		
		protected var frequencies:Array = [440, 494, 523, 587, 659, 698, 784];
		
		protected var catchFrequencies:Array = [];
		
		protected var lowFrequencies:Array = [];
		
		protected var humsDimmed:Boolean;
		
		public function SoundMan() 
		{
			
			for each(var freq:int in frequencies)
			{
				lowFrequencies.push(freq / 2);
				catchFrequencies.push(freq * 1.5);
			}
			
			tone = new Tone(440);
			catchTone = new Tone(catchFrequencies[0]);
			crash = new Crash();
			
			hums = new Array();
			humsDimmed = false;
			
			serveHum = new Hum(440);
		}
		
		public function playTone():void
		{
			tone.play();
			tone = new Tone(frequencies[Math.round(Math.random() * 7)]);
		}
		
		public function playCatchTone():void
		{
			catchTone.play();
			catchTone = new Tone(catchFrequencies[Math.round(Math.random() * 7)]);
		}
		
		public function playCrash():void
		{
			crash.play();
		}
		
		public function addHum(level:int = 0):void
		{
			var hum:Hum = new Hum(lowFrequencies[6 - level]);
			
			hum.play();
			
			for each (var h:Hum in hums)
			{
				h.volume *= 0.6;
			}
			
			if (hums.length > 2)
			{
				var droppedHum:Hum = hums.shift();
				droppedHum.stop();
			}
			
			hums.push(hum);
			
		}
		
		public function playServeHum(level:int = 0):void
		{

			serveHum.frequency = lowFrequencies[6 - level];
			serveHum.play();
			
			if (humsDimmed)
			{
				stopHums();
				humsDimmed = false;
			}

		}
		
		public function stopServeHum():void
		{
			serveHum.stop();
		}
		
		public function stopHums():void
		{
			for each (var hum:Hum in hums)
			{
				hum.stop();
			}
			
			hums = [];
		}
		
		public function dimHums():void
		{
			humsDimmed = true;
			
			for each (var hum:Hum in hums)
			{
				hum.volume *= 0.3;
			}
			
		}
		
		public function upgradeCurrentHum():void
		{
			var lastHum:Hum = hums[hums.length - 1];
			
			lastHum.frequency *= 2;
		}
		
	}

}